﻿// <auto-generated />
using System;
using LigovkaBudget.Data;
using LigovkaBudget.Infrastructure.Values;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Migrations;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;
using Npgsql.EntityFrameworkCore.PostgreSQL.Metadata;

namespace LigovkaBudget.Data.Migrations
{
    [DbContext(typeof(LigovkaBudgetContext))]
    [Migration("20201011140652_Initial")]
    partial class Initial
    {
        protected override void BuildTargetModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasAnnotation("Npgsql:Enum:budget_type", "project,decision,utilization")
                .HasAnnotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.IdentityByDefaultColumn)
                .HasAnnotation("ProductVersion", "3.1.4")
                .HasAnnotation("Relational:MaxIdentifierLength", 63);

            modelBuilder.Entity("LigovkaBudget.Data.Models.BudgetDataAlias", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("integer")
                        .HasAnnotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.IdentityByDefaultColumn);

                    b.Property<int?>("CodeId")
                        .HasColumnType("integer");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasColumnType("character varying(255)")
                        .HasMaxLength(255);

                    b.Property<int>("PresentationId")
                        .HasColumnType("integer");

                    b.HasKey("Id");

                    b.HasIndex("CodeId");

                    b.HasIndex("PresentationId");

                    b.ToTable("Aliases");
                });

            modelBuilder.Entity("LigovkaBudget.Data.Models.BudgetDataAliasRelation", b =>
                {
                    b.Property<int>("AliasId")
                        .HasColumnType("integer");

                    b.Property<int>("ParentAliasId")
                        .HasColumnType("integer");

                    b.HasKey("AliasId", "ParentAliasId");

                    b.HasIndex("ParentAliasId");

                    b.ToTable("AliasRelations");
                });

            modelBuilder.Entity("LigovkaBudget.Data.Models.BudgetDataAmount", b =>
                {
                    b.Property<int>("DetailsId")
                        .HasColumnType("integer");

                    b.Property<int>("CodeId")
                        .HasColumnType("integer");

                    b.Property<decimal>("Value")
                        .HasColumnType("numeric");

                    b.HasKey("DetailsId", "CodeId");

                    b.HasIndex("CodeId");

                    b.ToTable("Amounts");
                });

            modelBuilder.Entity("LigovkaBudget.Data.Models.BudgetDataCode", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("integer")
                        .HasAnnotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.IdentityByDefaultColumn);

                    b.Property<int>("MunicipalityId")
                        .HasColumnType("integer");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasColumnType("character varying(1000)")
                        .HasMaxLength(1000);

                    b.Property<string>("Number")
                        .IsRequired()
                        .HasColumnType("character varying(255)")
                        .HasMaxLength(255);

                    b.HasKey("Id");

                    b.HasIndex("MunicipalityId", "Number")
                        .IsUnique();

                    b.ToTable("Codes");
                });

            modelBuilder.Entity("LigovkaBudget.Data.Models.BudgetDataDetails", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("integer")
                        .HasAnnotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.IdentityByDefaultColumn);

                    b.Property<DateTime>("Date")
                        .HasColumnType("date");

                    b.Property<int>("MunicipalityId")
                        .HasColumnType("integer");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasColumnType("character varying(255)")
                        .HasMaxLength(255);

                    b.Property<BudgetType>("Type")
                        .HasColumnType("budget_type");

                    b.Property<int>("Year")
                        .HasColumnType("integer");

                    b.HasKey("Id");

                    b.ToTable("Details");
                });

            modelBuilder.Entity("LigovkaBudget.Data.Models.BudgetDataPresentation", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("integer")
                        .HasAnnotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.IdentityByDefaultColumn);

                    b.Property<int>("MunicipalityId")
                        .HasColumnType("integer");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasColumnType("character varying(255)")
                        .HasMaxLength(255);

                    b.HasKey("Id");

                    b.HasIndex("MunicipalityId", "Name")
                        .IsUnique();

                    b.ToTable("Presentations");
                });

            modelBuilder.Entity("LigovkaBudget.Data.Models.BudgetDataAlias", b =>
                {
                    b.HasOne("LigovkaBudget.Data.Models.BudgetDataCode", "Code")
                        .WithMany()
                        .HasForeignKey("CodeId");

                    b.HasOne("LigovkaBudget.Data.Models.BudgetDataPresentation", "Presentation")
                        .WithMany()
                        .HasForeignKey("PresentationId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();
                });

            modelBuilder.Entity("LigovkaBudget.Data.Models.BudgetDataAliasRelation", b =>
                {
                    b.HasOne("LigovkaBudget.Data.Models.BudgetDataAlias", "Alias")
                        .WithMany()
                        .HasForeignKey("AliasId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("LigovkaBudget.Data.Models.BudgetDataAlias", "ParentAlias")
                        .WithMany()
                        .HasForeignKey("ParentAliasId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();
                });

            modelBuilder.Entity("LigovkaBudget.Data.Models.BudgetDataAmount", b =>
                {
                    b.HasOne("LigovkaBudget.Data.Models.BudgetDataCode", "Code")
                        .WithMany()
                        .HasForeignKey("CodeId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("LigovkaBudget.Data.Models.BudgetDataDetails", "Details")
                        .WithMany()
                        .HasForeignKey("DetailsId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();
                });
#pragma warning restore 612, 618
        }
    }
}
